#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define _INS_
#define PAROLA_CHIAVE "ozlap"
#define CANCELLETTO (int)'#'
#define PIU '+'
#define PIPE '|'
#define QUADRA '['
#define ACAPO '\n'
#define PUNTO '.'
#define VIRGOLA ','
#define DUEPUNTI ':'
#define PTOVIRGOLA ';'
#define TONDAA '('
#define TONDAC ')'
#define APICE '\"'
#define MENO '-'
#define INTERROGATIVO '?'
#define MAXLINE 1500
#define MAXWORD 150

typedef struct dict {
         char parola[MAXWORD];
         struct dict *next;
        } Parole;

/* Controlla se una parola e' presente nella lista */
int isin(Parole *voc, char par[MAXWORD])
{
 int found=0;
 Parole *loc;
 loc = voc;
 while ((loc) && (!found)) {
    if (strcmp(loc->parola, par) == 0)
      found=1;
    loc = loc->next;
 } 
 return(found);
}
/* Inserisce in testa: veloce ma lista rovesciata */
Parole *cons(char *par, Parole *l)
{
 Parole *p;
 
 p = (Parole *)malloc(sizeof(Parole));
 strcpy(p->parola, par);
 p->next = l;
 return p;
}
/* Inserisce in coda: elementi nel loro ordine ma + lenta */
Parole *ins(char *par, Parole *l)
{
 Parole *p, *loc;
 
 p = (Parole *)malloc(sizeof(Parole));
 strcpy(p->parola, par);
 p->next = NULL;
 if (l == NULL)
    return p;
  else {
    loc = l;
    while (loc->next != NULL)
      loc = loc->next;
    loc->next = p;
    return (l);
  }
}
/* Distrugge la lista */
void dispose(Parole *old)
{
 Parole *loc;
 
 while (old != NULL) {
   loc = old->next;
   free(old);
   old = loc;
 }
}

int main(int argc, char *argv[])
{
 FILE *f1, *f2;
 char riga[MAXLINE];

 Parole *vocabolario;
 
 if (argc != 2) {
   printf("Bisogna indicare il nome del file\n");
   exit(1);
 }
 if ((f1 = fopen (argv[1],"r")) == NULL) {
   printf("Impossibile aprire il file di input\n");
   exit(1);
 }
 #define FILE_OUTPUT "voc.txt" // per ora e' fisso x semplicita'...
 if ((f2 = fopen (FILE_OUTPUT, "w")) == NULL) {
   printf("Impossibile aprire il file di output\n");
   exit(1);
 }
 
 vocabolario = NULL;
 
 while ((!feof(f1)) && (fscanf(f1, "%s", riga))) {
   if ((riga[0]==(int)PIPE) || (riga[0]==(int)QUADRA) || 
       (riga[0]==(int)ACAPO) || (riga[0]==(int)PUNTO) ||
       (riga[0]==(int)VIRGOLA) || (riga[0]==(int)DUEPUNTI) ||
       (riga[0]==(int)PTOVIRGOLA) || (riga[0]==(int)TONDAA) ||
       (riga[0]==(int)TONDAC) || (riga[0]==(int)APICE) ||
       (riga[0]==(int)MENO) || (riga[0]==(int)INTERROGATIVO) ||
       (strcmp(riga, "SENTENCE") == 0) || (strstr(riga, PAROLA_CHIAVE)));
     else 
     {
           if (!isin(vocabolario, riga)) 
/*#ifdef _INS_*/
//		vocabolario = ins(riga, vocabolario);
/*#else*/
		vocabolario = cons(riga, vocabolario);
/*#endif*/
   } // fine operazioni per le righe non banali

   // passo alla riga successiva
   
   }
 
 fclose (f1);
 // stampiamo la lista sul file (e' rovesciata se creata con la cons)...
 while (vocabolario != NULL) {
   fprintf(f2, "%s\n", vocabolario->parola);
   vocabolario = vocabolario->next;
 }
 fclose (f2);
 dispose(vocabolario);
 return (0);
}
